 

import javax.swing.*;
import java.awt.Point;
import java.awt.Insets;


/**
 * Classe BorderButton impl?mentant un bouton de marge pour une tableau
 * SpreadSheet.
 * 
 * @author Denis Di Filippantonio for Dynasite
 * @date 03/04/2003
 * @version 1.1
 */
class BorderButton extends JButton
{
	
	/************************ Variables d'instance ******************************
	 * position de la cellule sur la marge: si le premier indice est 0,
	 * il s'agit de la marge de gauche, s'il vaut 1, c'est la marge sup?rieure
	 * Le bouton en haut ? gauche a comme position 0,-1
	 */
	private Point position;	
	
	/************************ Constructeur **************************************
	 *
	 * Constructeur
	 *
	 * @param Point pos: p.x = 0 ou 1, p.y >= -1
	 * @post un nouveau bouton du tableau est cr?? ? la position pos
	 */
	public BorderButton(Point pos){
		position = new Point(pos);
		
		String text = "";
		if (pos.x == 0 && pos.y == -1)		text = "";
		else if(pos.x ==0)					text = String.valueOf(pos.y+1);
		else if (pos.x == 1)
		{
			int r = pos.y;
			do {
					text = String.valueOf((char) ((r % 26) + 'A')) + text;
					r = (r - (r % 26)) / 26 - 1;
				} while (r != -1);
		}
		setText(text);
		setHorizontalAlignment(SwingConstants.CENTER);
		setFont(getFont().deriveFont(10f));
		Insets m = getMargin();
		m.bottom = 0;
		m.top = 0;
		setMargin(m);
	}
	
	/*************** M?thode de l'interface CellInterf **************************/
	public Point getLocation(){				return new Point(position);}
	public void setLocation(Point p){			position = p;}
}
