//Copyright 2004 Xavier Damman (xavier at tribal dot be)
//This file is part of phpDynaSite
//phpDynaSite is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.undo.*;
import java.util.*;

public class TextEditor extends JApplet {
	
	private final String icones = "";
	
	private JPanel monPanel;
	private JEditorPane jep;
	private HTMLDocument sd;
	private UndoManager undo;
//	private XavierViewFactory xavierFact = new XavierViewFactory();
	
	private JButton bundo;
	private JButton bredo;
	private JButton bgras;
	private JButton bital;
	private JButton bunde;
	private JButton bpuce;
	private JButton bleft;
	private JButton bcent;
	private JButton brigh;
	
	private JComboBox cbtaille;
	private JComboBox cbpolice;
	private JComboBox cbcouleur;
	private JComboBox cbstyle;
	
	/*
	 *  Les styles sont form?s de :
	 *  1. Nom du style
	 *  2. Police
	 *  3. Taille
	 *  4. Couleur
	 *  5. Alignement ('C' = centr?, 'R' = droite, 'L' = gauche)
	 *  6. Gras ('O' pour oui, 'N' pour non)
	 *  7. Italique ('O' pour oui, 'N' pour non)
	 *  8. Soulign? ('O' pour oui, 'N' pour non)
	 */
	
	/*private String[][] styles = {
	{"Titre", "Arial Black", "7", "Noir", "C", "O", "N", "O"}, 
	{"Normal", "Times New Roman", "4", "Noir", "L", "N", "N", "N"},
	{"Important", "Impact", "5", "Rouge", "L", "N", "N", "N"}, 
	{"Code", "Courier New", "4", "Noir", "L", "N", "N", "N"}, 
	{"Note", "Times New Roman", "4", "Gris", "L", "N", "O", "N"}
	};*/
	
	private String[][] styles;
	private final String styleDelim = "|";
	private final String valueDelim = ",";
	private final String[] styleDefaut = {"Defaut", "Times New Roman", "4", "Noir", "L", "N", "N", "N"};
	private int startstyle;
	
	private boolean bonneVersion = true;
	
	public void init() {
		System.out.println("*" + System.getProperty("java.version"));
		if (System.getProperty("java.version").indexOf("1.4")==-1) {
			bonneVersion = false;
			System.out.println("mauvaise version de Java ");
			return;
		}
		bonneVersion = true;
//
//		AllowedLocation thisScript= new AllowedLocation(getCodeBase().toString());
//		if(!thisScript.isAllowed())
//		{
//			String errorMsg = thisScript.getErrorMsg();
//			monPanel = (JPanel) getContentPane();
//			JTextPane textMsg = new JTextPane();
//			textMsg.setText(errorMsg);
//			monPanel.add(textMsg);
//			System.out.println(errorMsg);
//			return;
//		}

		monPanel = (JPanel) getContentPane();
		monPanel.setBackground(Color.white);
		
		String stylesstring = getParameter("styles");
		Vector vvv = new Vector();
		StringTokenizer stok = new StringTokenizer(stylesstring, styleDelim, false);
		while(stok.hasMoreTokens()) {
			vvv.add(stok.nextToken());
		}
		
		//System.out.println(vvv);
		styles = new String[vvv.size()][8];
		String stast = getParameter("startstyle");
		
		for(int i = 0; i<styles.length; i++) {
			stok = new StringTokenizer((String) vvv.elementAt(i), valueDelim, false);
			int j = 0;
			try {
				//System.out.println("------------------");
				while(stok.hasMoreTokens()) {
					styles[i][j++] = stok.nextToken();
					//System.out.println(styles[i][j-1]);
				}
				if (styles[i][0].equals(stast))
					startstyle = i;
			} catch (Exception e) {
				e.printStackTrace();
				styles[i] = styleDefaut;
			}
		}
		
		bgras = new JButton(new ImageIcon(getImage(getCodeBase(), "bold.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bgras.setRequestFocusEnabled(false);
		bgras.setMargin(new Insets(1,1,1,1));
		
		bital = new JButton(new ImageIcon(getImage(getCodeBase(), "italic.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bital.setRequestFocusEnabled(false);
		bital.setMargin(new Insets(1,1,1,1));
		
		bunde = new JButton(new ImageIcon(getImage(getCodeBase(), "underline.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bunde.setRequestFocusEnabled(false);
		bunde.setMargin(new Insets(1,1,1,1));
		
		bpuce = new JButton(new ImageIcon(getImage(getCodeBase(), "bullets.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bpuce.setRequestFocusEnabled(false);
		bpuce.setMargin(new Insets(1,1,1,1));
		
		bleft = new JButton(new ImageIcon(getImage(getCodeBase(), "left.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bleft.setRequestFocusEnabled(false);
		bleft.setMargin(new Insets(1,1,1,1));
		
		bcent = new JButton(new ImageIcon(getImage(getCodeBase(), "center.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bcent.setRequestFocusEnabled(false);
		bcent.setMargin(new Insets(1,1,1,1));
		
		brigh = new JButton(new ImageIcon(getImage(getCodeBase(), "right.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		brigh.setRequestFocusEnabled(false);
		brigh.setMargin(new Insets(1,1,1,1));
		
		bundo = new JButton(new ImageIcon(getImage(getCodeBase(), "undo.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bundo.setRequestFocusEnabled(false);
		bundo.setMargin(new Insets(1,1,1,1));
		
		bredo = new JButton(new ImageIcon(getImage(getCodeBase(), "redo.gif"))) {
			public float getAlignmentY() { return 0.5f; }
		};
		bredo.setRequestFocusEnabled(false);
		bredo.setMargin(new Insets(1,1,1,1));
		
		monPanel.setLayout(new BorderLayout());
		
		jep = new JEditorPane("text/html", "");
		jep.setEditorKit(new HTMLEditorKit() {
//				public ViewFactory getViewFactory() {
//					return xavierFact;
//				}
			});
		
		sd = (HTMLDocument) jep.getDocument();
		
		undo = new UndoManager();
		sd.addUndoableEditListener(undo);
		
		//JPanel pbutton = new JPanel();
		//pbutton.setLayout(new BoxLayout(pbutton, BoxLayout.Y_AXIS));
		JPanel pbut1 = new JPanel();
		//JPanel pbut2 = new JPanel();
		JPanel pbut21 = new JPanel();
		JPanel pbut22 = new JPanel();
		JPanel pbut23 = new JPanel();
		JPanel pbut24 = new JPanel();
		//pbutton.add(pbut1);
		//pbutton.add(pbut2);
		pbut1.setBackground(Color.white);
		pbut21.setBackground(Color.white);
		pbut22.setBackground(Color.white);
		pbut23.setBackground(Color.white);
		pbut24.setBackground(Color.white);
		
		FlowLayout flbut = new FlowLayout(FlowLayout.CENTER, 0, 3);
		pbut21.setLayout(flbut);
		pbut22.setLayout(flbut);
		pbut23.setLayout(flbut);
		pbut24.setLayout(flbut);
		
		cbtaille = new JComboBox();
		cbtaille.addItem("3");
		cbtaille.addItem("4");
		cbtaille.addItem("5");
		cbtaille.addItem("6");
		cbtaille.addItem("7");
		cbtaille.setPreferredSize(new Dimension(34, 20));
		cbtaille.setFont(new Font(cbtaille.getFont().getName(), Font.PLAIN, 10));
		cbtaille.setEditable(true);
		cbtaille.setSelectedIndex(1);
		
		String[] polices = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		cbpolice = new JComboBox();
		for (int i = 0;i<polices.length;i++) {
			cbpolice.addItem(polices[i]);
		}
		cbpolice.setPreferredSize(new Dimension(115, 20));
		cbpolice.setSelectedItem("Times New Roman");
		cbpolice.setFont(new Font(cbpolice.getFont().getName(), Font.PLAIN, 10));
		
		cbcouleur = new JComboBox();
		cbcouleur.addItem("Noir");
		cbcouleur.addItem("Rouge");
		cbcouleur.addItem("Vert");
		cbcouleur.addItem("Bleu");
		cbcouleur.addItem("Jaune");
		cbcouleur.addItem("Gris");
		
		cbcouleur.setPreferredSize(new Dimension(38, 20));
		cbcouleur.setSelectedIndex(0);
		//cbcouleur.setFont(new Font(cbcouleur.getFont().getName(), Font.PLAIN, 10));
		cbcouleur.setRenderer(new ListCellRenderer() {
				public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
					if (value.toString().equals("Noir")) {
						return new ColoredText(Color.black);
					}
					else if (value.toString().equals("Rouge")) {
						return new ColoredText(Color.red);
					}
					else if (value.toString().equals("Vert")) {
						return new ColoredText(Color.green);
					}
					else if (value.toString().equals("Bleu")) {
						return new ColoredText(Color.blue);
					}
					else if (value.toString().equals("Jaune")) {
						return new ColoredText(Color.yellow);
					}
					else if (value.toString().equals("Gris")) {
						return new ColoredText(Color.gray);
					}
					else return new ColoredText(Color.black);
				}
			});
		cbstyle = new JComboBox();
		for (int i = 0;i<styles.length;i++) {
			cbstyle.addItem(styles[i][0]);
		}
		cbstyle.setPreferredSize(new Dimension(65, 20));
		cbstyle.setFont(new Font(cbstyle.getFont().getName(), Font.PLAIN, 10));
		
		
		pbut21.add(bpuce);
		pbut22.add(bundo);
		pbut22.add(bredo);
		pbut23.add(bgras);
		pbut23.add(bital);
		pbut23.add(bunde);
		pbut24.add(bleft);
		pbut24.add(bcent);
		pbut24.add(brigh);
		
		pbut1.add(cbtaille);
		pbut1.add(cbpolice);
		pbut1.add(cbcouleur);
		pbut1.add(cbstyle);
		pbut1.add(pbut22);
		pbut1.add(pbut21);
		pbut1.add(pbut23);
		pbut1.add(pbut24);
		
		monPanel.setLayout(new BorderLayout());
		JScrollPane jsp = new JScrollPane(jep);
		monPanel.add(jsp, BorderLayout.CENTER);
		monPanel.add(pbut1, BorderLayout.NORTH);
		
		bredo.setEnabled(false);
		
		bgras.addActionListener(new EditorListener(jep, 0, this));
		bital.addActionListener(new EditorListener(jep, 1, this));
		bunde.addActionListener(new EditorListener(jep, 2, this));
		bleft.addActionListener(new EditorListener(jep, 3, this));
		bcent.addActionListener(new EditorListener(jep, 4, this));
		brigh.addActionListener(new EditorListener(jep, 5, this));
		cbtaille.addActionListener(new EditorListener(jep, 6, this));
		
		bpuce.addActionListener(new EditorListener(jep, 7, this));
		
		cbpolice.addActionListener(new EditorListener(jep, 8, this));
		cbcouleur.addActionListener(new EditorListener(jep, 9, this));
		
		cbstyle.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					int i = 0;
					while (i<styles.length) {
						if (cbstyle.getSelectedItem().equals(styles[i][0]))
							break;
						i++;
					}
					
					cbpolice.setSelectedItem(styles[i][1]);
					cbtaille.setSelectedItem(styles[i][2]);
					cbcouleur.setSelectedItem(styles[i][3]);
					
					Element elem = null;
					if (jep.getSelectionEnd()-jep.getSelectionStart() == 0) {
						elem = sd.getCharacterElement(jep.getSelectionEnd());
					}
					else {
						elem = sd.getCharacterElement(jep.getSelectionEnd()-1);
					}
					AttributeSet as = elem.getAttributes();
					Enumeration enu = as.getAttributeNames();
					
					final ActionEvent ae3 = new ActionEvent(jep, 0, "G");
					final HTMLEditorKit.BoldAction ba = new HTMLEditorKit.BoldAction(); 
					ba.actionPerformed(ae3);
					if (styles[i][5].equals("O")) {
						Object attr = as.getAttribute(CSS.Attribute.FONT_WEIGHT);
						if (attr!=null && attr.toString().equals("normal")) {
							ba.actionPerformed(ae3);
						}
					}
					else {
						Object attr = as.getAttribute(CSS.Attribute.FONT_WEIGHT);
						if (attr!=null && !(attr.toString().equals("normal"))) {
							ba.actionPerformed(ae3);
						}
						else if (attr==null && jep.getSelectionEnd()-jep.getSelectionStart()==0) {
							if (sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.FONT_WEIGHT) == null) {
								ba.actionPerformed(ae3);
							}
							else if ((sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.FONT_WEIGHT).toString().equals("normal"))) {
								ba.actionPerformed(ae3);
							}
						}
					}
					
					final ActionEvent ae2 = new ActionEvent(jep, 0, "I");
					final HTMLEditorKit.ItalicAction ia = new HTMLEditorKit.ItalicAction(); 
					ia.actionPerformed(ae2);
					if (styles[i][6].equals("O")) {
						Object attr = as.getAttribute(CSS.Attribute.FONT_STYLE);
						if (attr!=null && !(attr.toString().equals("italic"))) {
							ia.actionPerformed(ae2);
						}
					}
					else {
						Object attr = as.getAttribute(CSS.Attribute.FONT_STYLE);
						if (attr!=null && (attr.toString().equals("italic"))) {
							ia.actionPerformed(ae2);
						}
						else if (attr==null && jep.getSelectionEnd()-jep.getSelectionStart()==0) {
							if (sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.FONT_STYLE) == null) {
								ia.actionPerformed(ae2);
							}
							else if ((! sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.FONT_STYLE).toString().equals("italic"))) {
								ia.actionPerformed(ae2);
							}
						}
					}
					
					final ActionEvent ae4 = new ActionEvent(jep, 0, "S");
					final HTMLEditorKit.UnderlineAction ua = new HTMLEditorKit.UnderlineAction(); 
					ua.actionPerformed(ae4);
					if (styles[i][7].equals("O")) {
						Object attr = as.getAttribute(CSS.Attribute.TEXT_DECORATION);
						if (attr!=null && !(attr.toString().equals("underline"))) {
							ua.actionPerformed(ae4);
						}
					}
					else {
						Object attr = as.getAttribute(CSS.Attribute.TEXT_DECORATION);
						if (attr!=null && (attr.toString().equals("underline"))) {
							ua.actionPerformed(ae4);
						}
						else if (attr==null && jep.getSelectionEnd()-jep.getSelectionStart()==0) {
							if (sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.TEXT_DECORATION) == null) {
								ua.actionPerformed(ae4);
							}
							else if ((! sd.getCharacterElement(jep.getCaretPosition()-1).getAttributes().
								getAttribute(CSS.Attribute.TEXT_DECORATION).toString().equals("underline"))) {
								ua.actionPerformed(ae4);
							}
						}
					}
					
					if (styles[i][4].equals("C")) {
						final ActionEvent ae0 = new ActionEvent(jep, 0, "C");
						final HTMLEditorKit.AlignmentAction aa = new HTMLEditorKit.AlignmentAction("center", StyleConstants.ALIGN_CENTER);
						aa.actionPerformed(ae0);
					}
					else if (styles[i][4].equals("R")) {
						final ActionEvent ae0 = new ActionEvent(jep, 0, "R");
						final HTMLEditorKit.AlignmentAction aa = new HTMLEditorKit.AlignmentAction("right", StyleConstants.ALIGN_RIGHT);
						aa.actionPerformed(ae0);
					}
					else {
						final ActionEvent ae0 = new ActionEvent(jep, 0, "L");
						final HTMLEditorKit.AlignmentAction aa = new HTMLEditorKit.AlignmentAction("left", StyleConstants.ALIGN_LEFT);
						aa.actionPerformed(ae0);
					}
				}
			});
		
		bundo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					undo.undo();
					bredo.setEnabled(true);
					if (!undo.canUndo())
						bundo.setEnabled(false);
					jep.grabFocus();
				}
			});
		
		bredo.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					undo.redo();
					bundo.setEnabled(true);
					if (!undo.canRedo())
						bredo.setEnabled(false);
					jep.grabFocus();
				}
			});
		
		jep.addCaretListener(new CaretListener() {
				public void caretUpdate(CaretEvent ce) {
					if (!undo.canUndo())
						bundo.setEnabled(false);
					else 
						bundo.setEnabled(true);
					
					if (!undo.canRedo())
						bredo.setEnabled(false);
					else 
						bredo.setEnabled(true);
					int posit = jep.getCaretPosition()-1;
					if (posit==-1) posit = 0;
					Element elem = sd.getCharacterElement(posit);
					AttributeSet as = elem.getAttributes();
					Enumeration enu = as.getAttributeNames();
					Object attr;
					String taille = styles[startstyle][2];
					String police = styles[startstyle][1];
					Integer couleur = new Integer(Color.black.getRGB());
					String name = styles[startstyle][3];
					
					if (name.equals("Rouge")) {
						couleur = new Integer(Color.red.getRGB());
					}
					else if (name.equals("Jaune")) {
						couleur = new Integer(Color.yellow.getRGB());
					}
					else if (name.equals("Vert")) {
						couleur = new Integer(Color.green.getRGB());
					}
					else if (name.equals("Bleu")) {
						couleur = new Integer(Color.blue.getRGB());
					}
					else if (name.equals("Gris")) {
						couleur = new Integer(Color.gray.getRGB());
					}
					
					while(enu.hasMoreElements()) {
						attr = enu.nextElement();
						if (attr.equals(StyleConstants.FontSize)) {
							taille = (String) as.getAttribute(StyleConstants.FontSize);
						}
						else if (attr.equals(StyleConstants.FontFamily)) {
							police = (String) as.getAttribute(StyleConstants.FontFamily);
						}
						else if (attr.equals(StyleConstants.Foreground)) {
							couleur = new Integer((String) as.getAttribute(StyleConstants.FontFamily));
						}
						if (attr.equals(CSS.Attribute.FONT_SIZE)) {
							taille = as.getAttribute(CSS.Attribute.FONT_SIZE).toString();
						}
						else if (attr.equals(CSS.Attribute.FONT_FAMILY)) {
							police = as.getAttribute(CSS.Attribute.FONT_FAMILY).toString();
						}
						else if (attr.equals(CSS.Attribute.COLOR)) {
							couleur = Integer.valueOf(as.getAttribute(CSS.Attribute.COLOR).toString().substring(1), 16);
						}
					}
					
					String stcoul = "Noir";
					if (new Color(couleur.intValue()).equals(Color.red)) {
						stcoul = "Rouge";
					}
					else if (new Color(couleur.intValue()).equals(Color.green)) {
						stcoul = "Vert";
					}
					else if (new Color(couleur.intValue()).equals(Color.gray)) {
						stcoul = "Gris";
					}
					else if (new Color(couleur.intValue()).equals(Color.yellow)) {
						stcoul = "Jaune";
					}
					else if (new Color(couleur.intValue()).equals(Color.blue)) {
						stcoul = "Bleu";
					}
					
					EditorListener.change = true;
					if (!(cbtaille.getSelectedItem().equals(taille))) cbtaille.setSelectedItem(taille);
					if (!(cbpolice.getSelectedItem().equals(police))) cbpolice.setSelectedItem(police);
					if (!(cbcouleur.getSelectedItem().equals(stcoul))) cbcouleur.setSelectedItem(stcoul);
					EditorListener.change = false;
					//System.out.println("caret : "+jep.getCaretPosition());
				}
			});
		
		jep.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					if (e.getKeyChar()=='\n') {
						Element el = getPuceElement();
						if (el!=null && el.getEndOffset()-1==jep.getCaretPosition()) {
							//undo.undo();
							final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
							EditorListener.puceinc.actionPerformed(ae2);
							try {
								sd.remove(jep.getCaretPosition()+1, 1);
							} catch (Exception exc) {exc.printStackTrace();}
							return;
						}
						else if (el!=null) {
							final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
							EditorListener.puceinc.actionPerformed(ae2);
							try {
								sd.remove(jep.getCaretPosition(), 1);
							} catch (Exception exc) {exc.printStackTrace();}
							return;
						}
						/*else {
						cbstyle.setSelectedItem("Normal");
						}*/
					}
					else if (e.getKeyChar()=='\b') {
						if (jep.getSelectedText()!=null) {
							return;
						}
						Element elem = sd.getCharacterElement(jep.getCaretPosition());
						while (elem!=null) {
							if (elem.getName().equals("li") || elem.getName().equals("p")) break;
							elem = elem.getParentElement();
						}
						
						if (elem!=null && elem.getName().equals("li") && elem.getStartOffset()==jep.getCaretPosition()) {
							Element elem2 = sd.getCharacterElement(elem.getStartOffset()-1);
							while (elem2!=null) {
								if (elem2.getName().equals("p")) break;
								elem2 = elem2.getParentElement();
							}
							if (elem2!=null) {
								try {
									
									String str = createHTML(sd.getText(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1), sd.getCharacterElement(elem.getStartOffset()), elem.getEndOffset());
									
									int in = elem.getStartOffset();
									try {
										sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() );
									} catch (BadLocationException ble) {
										sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
									}
									final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
									EditorListener.inserePara.actionPerformed(ae2);
									
									//sd.insertString(in, str, null);
									
									sd.insertBeforeStart(sd.getCharacterElement(in), str);
									
									jep.setCaretPosition(in);
									jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, 'a'));
									
									
									
									/*sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
									//sd.insertBeforeStart(elem, " ");
									
									final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
									EditorListener.inserePara.actionPerformed(ae2);
									EditorListener.inserePara.actionPerformed(ae2);
									EditorListener.inserePara.actionPerformed(ae2);
									jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, '\n'));*/
									//jep.setCaretPosition(elem.getEndOffset());
									//jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, '\n'));
									return;
								} catch(Exception exc) {
									exc.printStackTrace();
								}
							}
							else {
								try {
									String str = createHTML(sd.getText(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1), sd.getCharacterElement(elem.getStartOffset()), elem.getEndOffset());
									
									int in = elem.getStartOffset();
									try {
										sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() );
									} catch (BadLocationException ble) {
										sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
									}
									final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
									EditorListener.inserePara.actionPerformed(ae2);
									
									//sd.insertString(in, str, null);
									
									sd.insertBeforeStart(sd.getCharacterElement(in), str);
									jep.setCaretPosition(in);
									jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, 'a'));
									
									/*
									sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
									jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, 'a'));*/
									
									/*sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
									final ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
									EditorListener.inserePara.actionPerformed(ae2);
									jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, 'a'));*/
									
									//jep.setCaretPosition(jep.getCaretPosition()+1);
									//jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, '\n'));
									return;
								} catch(Exception exc) {
									exc.printStackTrace();
								}
							}
						}
						else if (elem!=null && elem.getName().equals("p") && elem.getStartOffset()==jep.getCaretPosition() && jep.getCaretPosition()!=0 && (getPuceElement(jep.getCaretPosition() - 1) != null)) {
							try {
								String str = sd.getText(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
								int in = elem.getStartOffset();
								String tocopy = createHTML(str, sd.getCharacterElement(in), elem.getEndOffset());
								boolean bfin = false;
								try {
									sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
								} catch (BadLocationException ble) {
									sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
									bfin = true;
								}
								boolean bmod = false;
								try {
									Element elemp = getPuceElement(in);
									if (elemp != null) {
										bmod = true;
										elemp = elemp.getParentElement();
										String ssss = "<li>";
										String allnightlong;
										if (bfin)
											allnightlong = createHTML(sd.getText(elemp.getStartOffset(), elemp.getEndOffset() - elemp.getStartOffset() - 1), sd.getCharacterElement(elemp.getStartOffset()), elemp.getEndOffset() - 1);
										else 
											allnightlong = createHTML(sd.getText(elemp.getStartOffset(), elemp.getEndOffset() - elemp.getStartOffset() - 1), sd.getCharacterElement(elemp.getStartOffset()), elemp.getEndOffset());
										
										ssss = ssss + allnightlong;
										int iiii = ssss.length() - 3;
										ssss = ssss.replaceAll("\n", "</li><li>");
										ssss = ssss + "</li>";
										sd.remove(in-1, iiii);
										Element elemb = getPuceElement(in-1);
										sd.insertBeforeEnd(elemb, ssss);
									}
								} catch (Exception eex) {
									eex.printStackTrace();
								}
								sd.insertAfterEnd(sd.getCharacterElement(in-1), tocopy);
								if (bmod) {
									Element elemb = getPuceElement(in-1);
									if (elemb.getParentElement().getEndOffset() >= sd.getEndPosition().getOffset()-1) {
										sd.insertAfterEnd(elemb.getParentElement(), "<p></p>");
									}
									String pageh = jep.getText();
									pageh = pageh.replaceAll("\n", "");
									pageh = pageh.replaceAll("\r", "");
									jep.setText(pageh);
								}
								jep.setCaretPosition(in - 1);
							} catch(Exception ex) {ex.printStackTrace();}
							jep.dispatchEvent(new KeyEvent(jep, KeyEvent.KEY_TYPED, 1, 0, 0, 'a'));
							
							//jep.setCaretPosition(elem.getStartOffset() - 1);
						}
					}
					
					else if (e.getKeyChar()==26 && undo.canUndo()) {
						undo.undo();
						bredo.setEnabled(true);
						if (!undo.canUndo())
							bundo.setEnabled(false);
						
					}
					else if (e.getKeyChar()==25 && undo.canRedo()) {
						undo.redo();
						bundo.setEnabled(true);
						if (!undo.canRedo())
							bredo.setEnabled(false);
						
					}
					
					else if (e.getKeyChar()==7) {
						final ActionEvent ae3 = new ActionEvent(jep, 0, "G");
						final HTMLEditorKit.BoldAction ba = new HTMLEditorKit.BoldAction(); 
						ba.actionPerformed(ae3);
					}
					else if (e.getKeyChar()==9) {
						final ActionEvent ae2 = new ActionEvent(jep, 0, "I");
						final HTMLEditorKit.ItalicAction ia = new HTMLEditorKit.ItalicAction(); 
						ia.actionPerformed(ae2);
					}
					else if (e.getKeyChar()==19) {
						final ActionEvent ae4 = new ActionEvent(jep, 0, "S");
						final HTMLEditorKit.UnderlineAction ua = new HTMLEditorKit.UnderlineAction(); 
						ua.actionPerformed(ae4);
					}
				}
			});

		
		String color = new Integer(Color.black.getRGB()).toString();
		String name = styles[startstyle][3];
		if (name.equals("Rouge")) {
		    color = new Integer(Color.red.getRGB()).toString();
		}
		else if (name.equals("Jaune")) {
		    color = new Integer(Color.yellow.getRGB()).toString();
		}
		else if (name.equals("Vert")) {
		    color = new Integer(Color.green.getRGB()).toString();
		}
		else if (name.equals("Bleu")) {
		    color = new Integer(Color.blue.getRGB()).toString();
		}
		else if (name.equals("Gris")) {
		    color = new Integer(Color.gray.getRGB()).toString();
		}

	        //jep.setText("<p><font face=\""+styles[startstyle][1]+"\" color=\""+color+"\" size=\""+styles[startstyle][2]+"\">a</font></p>");
	        jep.setText("<p></p>");
		StyleContext sco = new StyleContext();
		Style def = sd.addStyle("def", null);//sco.new NamedStyle();
		StyleSheet ssh = sd.getStyleSheet();
		ssh.addRule("body {font-family : "+styles[startstyle][1]+"}");
		ssh.addRule("body {font-size : "+new Integer((int) (new Integer(styles[startstyle][2]).intValue()*3.7)).toString()+"}");
		name = styles[startstyle][3];
		color = "black";
		if (name.equals("Rouge")) {
		    color = "red";
		}
		else if (name.equals("Jaune")) {
		    color = "yellow";
		}
		else if (name.equals("Vert")) {
		    color = "green";
		}
		else if (name.equals("Bleu")) {
		    color = "blue";
		}
		else if (name.equals("Gris")) {
		    color = "grey";
		}
		ssh.addRule("body {color : "+color+"}");

		/*def.addAttribute(HTML.Attribute.FACE, styles[startstyle][1]);
		def.addAttribute(HTML.Attribute.SIZE, styles[startstyle][2]);
		//def.addAttribute(CSS.Attribute.COLOR, styles[startstyle][3]);
		
		if (styles[startstyle][6].equals("C"))
		def.addAttribute(CSS.Attribute.TEXT_ALIGN, "center");
		else if (styles[startstyle][6].equals("R"))
		def.addAttribute(CSS.Attribute.TEXT_ALIGN, "right");
		else
		def.addAttribute(CSS.Attribute.TEXT_ALIGN, "left");
		if (styles[startstyle][6].equals("O"))
		def.addAttribute(CSS.Attribute.FONT_STYLE, "italic");
		if (styles[startstyle][5].equals("O"))
		def.addAttribute(CSS.Attribute.FONT_WEIGHT, "bold");
		if (styles[startstyle][7].equals("O"))
		def.addAttribute(CSS.Attribute.TEXT_DECORATION, "underline");
		
		System.out.println("hep1 " + styles[startstyle][1]);
		//sd.setCharacterAttributes(0, 100, def, false);
		sd.setLogicalStyle(0, def);
		sd.setLogicalStyle(1, def);
		System.out.println("hep2 " + sd.getLogicalStyle(0));
		
		jep.select(0, 1);*/
		
		try {
		    cbstyle.setSelectedItem(getParameter("startstyle"));
		} catch (Exception e) {
			e.printStackTrace();
		}
		//cbtaille.setSelectedItem(styles[startstyle][2]);

		System.out.println("fini");
		jep.grabFocus();
		bundo.setEnabled(false);
		//jep.select(0, 1);
		
		try
		{
			String data = getParameter("data");
			setHTML(data);
		}catch(Exception e)
		{
			System.out.println("Erreur dans le passage des data en param?tre");
		}
		
	}
	
	public void createPuceSel(boolean puce) {
		try {
			int inte = jep.getCaretPosition();
			Element elem = sd.getCharacterElement(jep.getCaretPosition());
			while (elem!=null) {
				if (elem.getName().equals("li") || elem.getName().equals("p")) break;
				elem = elem.getParentElement();
			}
			String str = sd.getText(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
			int in = elem.getStartOffset();
			String tocopy = createHTML(str, sd.getCharacterElement(in), elem.getEndOffset() - 1);
			try {
				sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
			} catch (BadLocationException ble) {
				sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
			}
			try {
				//ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
				//EditorListener.puceinc.actionPerformed(ae2);
				if (!puce)
					sd.insertBeforeStart(elem, "<UL><LI>"+tocopy+"</LI></UL>");
				else
					sd.insertBeforeStart(elem, "<LI>"+tocopy+"</UL>");
			} catch (Exception eex) {
				eex.printStackTrace();
			}
			jep.setCaretPosition(inte);
		} catch(Exception ex) {ex.printStackTrace();}
		/*try {
		int endSel = jep.getSelectionEnd();
		int inte = jep.getCaretPosition();
		Element elem = sd.getCharacterElement(jep.getSelectionStart());
		while (elem != null) {
		//Element elem = sd.getCharacterElement(jep.getCaretPosition());
		while (elem!=null) {
		if (elem.getName().equals("li") || elem.getName().equals("p")) break;
		elem = elem.getParentElement();
		}
		String str = sd.getText(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
		int in = elem.getStartOffset();
		String tocopy = createHTML(str, sd.getCharacterElement(in), elem.getEndOffset() - 1);
		try {
		sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset());
		} catch (BadLocationException ble) {
		sd.remove(elem.getStartOffset(), elem.getEndOffset() - elem.getStartOffset() - 1);
		}
		try {
		//ActionEvent ae2 = new ActionEvent(jep, 0, "Puce");
		//EditorListener.puceinc.actionPerformed(ae2);
		sd.insertBeforeStart(elem, "<UL><LI>"+tocopy+"</LI></UL>");
		} catch (Exception eex) {
		eex.printStackTrace();
		}
		int iel = elem.getEndOffset();
		elem = sd.getCharacterElement(elem.getEndOffset());
		if (elem.getEndOffset() > endSel || elem.getEndOffset() == iel) break;
		}
		jep.setCaretPosition(inte);
		} catch(Exception ex) {ex.printStackTrace();}*/
	}
	
	public String createHTML(String tout, Element first, int end) {
		String str = "";
		int startof = first.getStartOffset();
		Element e1 = first;
		while(e1!=null) {
			AttributeSet as = e1.getAttributes();
			//Enumeration enu = as.getAttributeNames();
			//while (enu.hasMoreElements()) {
			String endstring = "";
			String startstring = "";
			
			String fon = "";
			String size = "";
			String col = "";
			
			boolean bo = false;
			
			Object attr = as.getAttribute(CSS.Attribute.FONT_FAMILY);
			if (attr!=null) {
				fon = " face=\"" + attr.toString() + "\"";
				bo = true;
			}
			attr = as.getAttribute(CSS.Attribute.FONT_SIZE);
			if (attr!=null) {
				size = " size=\"" + attr.toString() + "\"";
				bo = true;
			}
			attr = as.getAttribute(CSS.Attribute.COLOR);
			if (attr!=null) {
				col = " color=\"" + attr.toString() + "\"";
				bo = true;
			}
			if (bo) {
				startstring = startstring + "<font" + fon+size+col + ">";
				endstring = "</font>" + endstring;
			}
			
			attr = as.getAttribute(CSS.Attribute.FONT_WEIGHT);
			if (attr!=null && (!attr.toString().equals("normal"))) {
				startstring = startstring + "<B>";
				endstring = "</B>" + endstring;
			}
			attr = as.getAttribute(CSS.Attribute.FONT_STYLE);
			if (attr!=null && (attr.toString().equals("italic"))) {
				startstring = startstring + "<I>";
				endstring = "</I>" + endstring;
			}
			attr = as.getAttribute(CSS.Attribute.TEXT_DECORATION);
			if (attr!=null && (attr.toString().equals("underline"))) {
				startstring = startstring + "<U>";
				endstring = "</U>" + endstring;
			}
			try {
				str = str + startstring + tout.substring(e1.getStartOffset() - startof, e1.getEndOffset() - startof) + endstring;
			} catch (Exception e) {
				str = str + startstring + tout.substring(e1.getStartOffset() - startof, e1.getEndOffset() - startof - 1) + endstring;
			}
			//}
			
			int iel = e1.getEndOffset();
			e1 = sd.getCharacterElement(e1.getEndOffset());
			if (e1.getEndOffset() > end || e1.getEndOffset() == iel) break;
		}
		return str;
	}
	
	public void refreshUndo() {
		if (!undo.canUndo())
			bundo.setEnabled(false);
		else 
			bundo.setEnabled(true);
		
		if (!undo.canRedo())
			bredo.setEnabled(false);
		else 
			bredo.setEnabled(true);
	}
	
	public Element getPuceElement() {
		Element elem = sd.getCharacterElement(jep.getCaretPosition());
		while (elem!=null) {
			//System.out.println(elem);
			if (elem.getName().equals("li")) break;
			elem = elem.getParentElement();
		}
		return elem;
	}
	
	public Element getPuceElement(int position) {
		Element elem = sd.getCharacterElement(position);
		while (elem!=null) {
			//System.out.println(elem);
			if (elem.getName().equals("li")) break;
			elem = elem.getParentElement();
		}
		return elem;
	}
	
	public boolean isOnPuce() {
		return (getPuceElement()!=null);
	}
	
	public UndoManager getUndoMan() {
		return undo;
	}
	
	public HTMLDocument getDoc() {
		return sd;
	}
	
	
	public String getHTML() {
		String pageh = jep.getText();
		pageh = pageh.substring(pageh.indexOf("<body>")+6);
		pageh = pageh.substring(0, pageh.indexOf("</body>"));
		pageh = pageh.replaceAll("\n", "");
		pageh = pageh.replaceAll("\r", "");
		
		//remplacement des <p> par les <div>
		pageh = pageh.replaceAll("<p ", "<div ");
		pageh = pageh.replaceAll("<p>", "<div>");
		pageh = pageh.replaceAll("</p>", "</div>");
		
		int offs = 0;
		while (true) {
		    int ind = pageh.indexOf("<div", offs);
		    if (ind == -1) break;
		    ind = pageh.indexOf(">", ind+1) + 1;
		    int end = pageh.indexOf("</div>", ind);
		    if (end == -1) break;
		    int startfont = pageh.indexOf("<font", ind);
		    int pgq = ind;
		    while (pageh.charAt(pgq+1) == '<') pgq = pageh.indexOf(">");
		    if (startfont > pgq || startfont == -1) {
			String s1 = pageh.substring(0, ind);
			int befend = end-1;
			while (pageh.charAt(befend) == ' ') befend--;
			String s2 = pageh.substring(ind, befend+1);
			String s3 = pageh.substring(befend+1, pageh.length());
			pageh = s1 + "<font >" + s2 + "</font>" + s3;
		    }
		    int endfont = pageh.indexOf(">", startfont);

		    int face = pageh.indexOf("face=", offs);
		    if (face > endfont || face == -1) {
			String s1 = pageh.substring(0, ind+6);
			String s2 = pageh.substring(ind+6, pageh.length());
			pageh = s1 + "face=\""+styles[startstyle][1]+"\" " + s2;
		    }
		    

		    String color = "#000000";

		    String name = styles[startstyle][3];
			    
		    if (name.equals("Rouge")) {
			color = "#ff0000";
		    }
		    else if (name.equals("Jaune")) {
			color = "#ffff00";
		    }
		    else if (name.equals("Vert")) {
			color = "#00ff00";
		    }
		    else if (name.equals("Bleu")) {
			color = "#0000ff";
		    }
		    else if (name.equals("Gris")) {
			color = "#808080";
		    }

			    /*String color = new Integer(Color.black.getRGB()).toString();
				String name = styles[startstyle][3];
				if (name.equals("Rouge")) {
				color = new Integer(Color.red.getRGB()).toString();
				}
				else if (name.equals("Jaune")) {
				color = new Integer(Color.yellow.getRGB()).toString();
				}
				else if (name.equals("Vert")) {
				color = new Integer(Color.green.getRGB()).toString();
				}
				else if (name.equals("Bleu")) {
				color = new Integer(Color.blue.getRGB()).toString();
				}
				else if (name.equals("Gris")) {
				color = new Integer(Color.gray.getRGB()).toString();
				}*/
		    
		    int col = pageh.indexOf("color=", offs);
		    if (col > endfont || col == -1) {
			String s1 = pageh.substring(0, ind+6);
			String s2 = pageh.substring(ind+6, pageh.length());
			pageh = s1 + "color=\"" + color + "\" " + s2;
		    }
		    int size = pageh.indexOf("size=", offs);
		    if (size > endfont || size == -1) {
			String s1 = pageh.substring(0, ind+6);
			String s2 = pageh.substring(ind+6, pageh.length());
			pageh = s1 + "size=\"" + styles[startstyle][2] + "\" " + s2;
		    }
		    offs = pageh.indexOf("</div>", offs) + 4;
		}
		
		return pageh;
	}
	
	public void setHTML(String s) {
		//remplacement des <div> par les <p>
		s = s.replaceAll("<div ", "<p ");
		s = s.replaceAll("<div>", "<p>");
		s = s.replaceAll("</div>", "</p>");
		
		if ((s.indexOf("</p>") < s.length() - 5) || (s.length() < 6)) 
			s = s.concat("<p> </p>");
		jep.setText("<html><head></head><body>" + s + "</body></html>");
	}
	
	public boolean getVersion() {
		return bonneVersion;
	}
	
	public boolean getURL() {
		return true;
	}
	
	class ColoredText extends Component {
		Color color;
		public ColoredText(Color c) {
			color = c;
		}
		
		public void paint(Graphics g) {
			g.setColor(color);
			g.setFont(new Font(jep.getFont().getName(), Font.PLAIN, 10));
			g.drawString("Aa", 0, 10);
			g.drawLine(0, 11, 12, 11);
		}
		public Dimension getPreferredSize() {
			return new Dimension(12, 12);
		}
	}
}

